]> git.saurik.com Git - apt.git/commitdiff
Add cron.daily
authorMatt Zimmerman <matt.zimmerman@canonical.com>
Sat, 13 Nov 2004 18:35:58 +0000 (18:35 +0000)
committerMatt Zimmerman <matt.zimmerman@canonical.com>
Sat, 13 Nov 2004 18:35:58 +0000 (18:35 +0000)
  * Patch from Michael Vogt to add an optional cron job which can run
    apt-get update periodically

debian/apt.cron.daily [new file with mode: 0644]
debian/changelog
debian/rules

diff --git a/debian/apt.cron.daily b/debian/apt.cron.daily
new file mode 100644 (file)
index 0000000..67b5874
--- /dev/null
@@ -0,0 +1,54 @@
+#!/bin/sh
+#
+# cron job for apt-get update
+#
+# Update-Package-Intervall is in days
+#
+STAMP=/var/lib/apt/update-stamp
+
+#set -e
+
+do_update()
+{
+    touch $STAMP.new
+    if apt-get update -qq; then
+       if [ -x /usr/bin/dbus-send ]; then
+           dbus-send --system / app.apt.dbus.updated boolean:true
+       fi
+        mv $STAMP.new $STAMP
+    fi
+    rm -f $STAMP.new
+}
+
+UpdateInterval=0
+RES=`apt-config shell UpdateInterval APT::Periodic::Update-Package-Lists`
+eval $RES
+
+if [ $UpdateInterval -eq 0 ]; then
+    exit 0
+fi
+
+# laptop check, on_ac_power returns:
+#       0 (true)    System is on mains power
+#       1 (false)   System is not on mains power
+#       255 (false) Power status could not be determined
+# Desktop systems always return 255 it seems
+if [ -x /usr/bin/on_ac_power ]; then
+    /usr/bin/on_ac_power 
+    if [ $? -eq 1 ]; then
+       exit 0
+    fi
+fi
+
+if [ ! -f $STAMP ]; then
+    do_update
+    exit 0
+fi
+
+LastUpdate=`stat -c "%Y" $STAMP 2>/dev/null` 
+Now=`date +%s`
+
+NeedUpdate=$(($LastUpdate+$UpdateInterval*3600*24))
+if [ $NeedUpdate -le $Now ]; then
+    do_update
+fi
index c5122fc54ae3506d6ac939dcdf4339e64a9e79bf..87a864c4e6829eda17f3b760b638cf03316b6e3c 100644 (file)
@@ -22,6 +22,8 @@ apt (0.5.28) unstable; urgency=low
     (Closes: #267266)
   * Set default Dpkg::MaxArgs to 1024, and Dpkg::MaxArgBytes to 32k.  Needed
     to work around ordering bugs when installing a large number of packages
+  * Patch from Michael Vogt to add an optional cron job which can run
+    apt-get update periodically
 
  -- 
 
index f54334fd93fadcc69988dd86ddb4477913f0f0b8..2dbb9707f0ecace63ae1450b52dbef7a61f21da4 100755 (executable)
@@ -211,7 +211,7 @@ apt: build debian/shlibs.local
 
        dh_installexamples -p$@ $(BLD)/docs/examples/*
        dh_installman -p$@ 
-
+       dh_installcron -p$@
        dh_installdocs -p$@
        dh_installchangelogs -p$@
        dh_strip -p$@